using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ArchitectWeaponBehaviour : MonoBehaviour
    {
        private LineRenderer LR;
        public bool IsPartyArchitect = false;
        public bool IsVoidArchitect = false;
        public bool IsEMPArchitect = false;
        public bool IsUltravioletArchitect = false;
        public bool IsExplosionArchitect = false;

        private void Awake()
        {
            this.LR = this.gameObject.AddComponent<LineRenderer>();
            this.LR.startWidth = 0.1f;
            this.LR.endWidth = 0.1f;
            this.LR.material = UnityEngine.Object.Instantiate<Material>(ModAPI.FindMaterial("VeryBright"));
            this.LR.material.mainTexture = ModAPI.LoadTexture("Textures/Beam.png");
            this.LR.sortingOrder = -5;
            this.LR.sortingLayerID = this.gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
        }
        #region FireWeapon 
        public void FireWeapon()
        {
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
            if (IsVoidArchitect == true)
            {
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    LR.enabled = true;
                    LR.startColor = new Color(1f, 1f, 1f, 1f);
                    LR.endColor = new Color(1f, 1f, 1f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(1f, 1f, 1f, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite11 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite11.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite22 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite22.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite33 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite33.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite44 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite44.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite55 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite55.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity); UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity); UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsExplosionArchitect == true)
            {
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                        LR.enabled = true;
                    LR.startColor = new Color(1f, 0f, 0f, 1f);
                    LR.endColor = new Color(1f, 0f, 0f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(1f, 0f, 0f, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite53 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite53.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite52 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite52.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite33 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite33.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f)
                    {
                        var Dynamite44 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite44.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite55 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite55.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Plastic Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite444.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite555.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite1111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite1111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite2222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite3333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite4444.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite5555.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5555a = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite5555a.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5555b = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite5555b.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsEMPArchitect == true)
            {
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    LR.enabled = true;
                    LR.startColor = new Color(0f, 0f, 1f, 1f);
                    LR.endColor = new Color(0f, 0f, 1f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(0f, 0f, 1f, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);

                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite1.gameObject);
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite2.gameObject);
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite3.gameObject);
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite4.gameObject);
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite5.gameObject);
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite1.gameObject);
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite2.gameObject);
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite3.gameObject);
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite4.gameObject);
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite5.gameObject);
                        var Dynamite11 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite11.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite11.gameObject);
                        var Dynamite22 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite22.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite22.gameObject);
                        var Dynamite33 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite33.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite33.gameObject);
                        var Dynamite44 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite44.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite44.gameObject);
                        var Dynamite55 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite55.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite55.gameObject);
                        var Dynamite111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite111.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite111.gameObject);
                        var Dynamite222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite222.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite222.gameObject);
                        var Dynamite333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite333.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite333.gameObject);
                        var Dynamite444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite444.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite444.gameObject);
                        var Dynamite555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite555.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite555.gameObject);
                        var Dynamite1111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite1111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite2222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite3333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite1.gameObject);
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite2.gameObject);
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite3.gameObject);
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite4.gameObject);
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite5.gameObject);
                        var Dynamite11 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite11.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite11.gameObject);
                        var Dynamite22 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite22.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite22.gameObject);
                        var Dynamite33 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite33.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite33.gameObject);
                        var Dynamite44 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite44.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite44.gameObject);
                        var Dynamite55 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite55.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite55.gameObject);
                        var Dynamite111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite111.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite111.gameObject);
                        var Dynamite222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite222.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite222.gameObject);
                        var Dynamite333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite333.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite333.gameObject);
                        var Dynamite444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite444.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite444.gameObject);
                        var Dynamite555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("EMP Generator").Prefab, hit.point, Quaternion.identity);
                        Dynamite555.gameObject.transform.GetComponent<EMPBehaviour>().Activate();
                        Destroy(Dynamite555.gameObject);
                        var Dynamite1111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite1111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite2222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite3333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, hit.point, Quaternion.identity);
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsUltravioletArchitect == true)
            {
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    LR.enabled = true;
                    LR.startColor = new Color(1f, 0f, 1f, 1f);
                    LR.endColor = new Color(1f, 0f, 1f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(1f, 0f, 1f, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);

                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();

                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f)
                    {
                        var Dynamite1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite1.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite11 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite11.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite22 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite22.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite33 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite33.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite44 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite44.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite55 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite55.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite444.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Dynamite").Prefab, hit.point, Quaternion.identity);
                        Dynamite555.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        var Dynamite2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite2.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite3 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite3.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite4 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite4.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite5 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pink Explosive").Prefab, hit.point, Quaternion.identity);
                        Dynamite5.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite111 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite111.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite222 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite222.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite333 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite333.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite444 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite444.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        var Dynamite555 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, hit.point, Quaternion.identity);
                        Dynamite555.gameObject.transform.GetComponent<ExplosiveBehaviour>().Activate();
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                        UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, hit.point, Quaternion.identity);
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsPartyArchitect == true)
            {
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    LR.enabled = true;
                    float RandomColor1 = UnityEngine.Random.Range(0.00f, 1.00f);
                    float RandomColor2 = UnityEngine.Random.Range(0.00f, 1.00f);
                    float RandomColor3 = UnityEngine.Random.Range(0.00f, 1.00f);

                    LR.startColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                    LR.endColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                    LR.material.SetColor("_GlowColour", new Color(RandomColor1, RandomColor2, RandomColor3, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f)
                    {
                        int RandomSpawnNumber0 = UnityEngine.Random.Range( 1, 9);
                        if (RandomSpawnNumber0 == 1)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 2)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 3)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 4)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 5)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 6)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 7)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber0 == 8)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f)
                    {
                        int RandomSpawnNumber = UnityEngine.Random.Range(1, 14);
                        if (RandomSpawnNumber == 1)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 2)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 3)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell A4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell B4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell C4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell D4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell C5").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell E4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell F4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell G4").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 4)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 5)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Balloon").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 6)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 7)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().Bursts.PickRandom<GameObject>(), hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 8)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell C5").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell E4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell F4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell G4").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 9)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell A4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell B4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell C4").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Bell D4").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 10)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 11)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 12)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber == 13)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Pumpkin").Prefab, hit.point, Quaternion.identity);
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        int RandomSpawnNumber2 = UnityEngine.Random.Range(1, 5);

                        if (RandomSpawnNumber2 == 1)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber2 == 2)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber2 == 3)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                        }
                        if (RandomSpawnNumber2 == 4)
                        {
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fireworks").Prefab.GetComponent<FireworksBehaviour>().FireworksNuke, hit.point, Quaternion.identity);
                        }
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }         
        }
        #endregion
        #region IEnumeratorLineRendererDisablerStuff

        public IEnumerator LineRendererDisabler()
        {
            yield return (object)new WaitForSeconds(0.15f);
            LR.enabled = false;
        }
        #endregion
    }
}