using System.Security.Cryptography;
using UnityEngine;
using System.Collections.Generic;
namespace MainModClass
{
    public class ArmorBehaviour : MonoBehaviour
    {
        private static readonly List<DecalControllerBehaviour> results = new List<DecalControllerBehaviour>();

        private bool equipped;
        public string armorPiece;
        public int armorTier;
        public float stabResistance;
        private bool blockingStab;
        public string otherSprite;
        public string otherName;
        public string otherPiece;
        public float otherResist;
        public float mass;
        public int otherTier;
        public bool threepieces;
        public string thirdsprite;
        public string thirdpart;

        public bool IsHeadcrab;
        public bool IsSkulkcrab;
        public bool IsNormalHeadcrab; 
        public bool IsPoisonHeadcrab;
        public bool IsFastHeadcrab;
        public SpriteRenderer HeadcrabBackLegsSprite;

        public void Update()
        {
            if (!this.equipped || !(bool)(Object)this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>() || !(bool)(Object)this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding)
                return;
            this.Nocollide(this.GetComponent<FixedJoint2D>().connectedBody.gameObject.GetComponent<GripBehaviour>().CurrentlyHolding.gameObject);
        }

        public void OnCollisionEnter2D(Collision2D collision)
        {
            LimbBehaviour component1 = collision.gameObject.GetComponent<LimbBehaviour>();
            ArmorBehaviour component2 = collision.gameObject.GetComponent<ArmorBehaviour>();
            if ((bool)(Object)component2)
                this.Nocollide(component2.gameObject);
            if ((bool)(Object)component1)
            {
                this.Nocollide(component1.gameObject);
                Debug.Log((object)component1.gameObject.ToString());
                Debug.Log((object)this.armorPiece);
                if (!this.equipped && component1.gameObject.ToString() == this.armorPiece + " (UnityEngine.GameObject)")
                {
                    if (IsHeadcrab == true)
                    {
                        bool HasAlreadyHeadcrab = false;
                        foreach (Transform child in component1.transform)
                        {
                            if(child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null && child.transform != component1.transform)
                            {
                                HasAlreadyHeadcrab = true;
                            }
                        }
                        if (HasAlreadyHeadcrab == false)
                        {

                            this.Nocollide(component1.gameObject);
                            Debug.Log((object)"HeadcrabLatched!");
                            this.Attach(component1);
                            transform.GetComponent<NormalHeadcrabInfectionBehaviour>().HeadcrabHost = collision.gameObject;
                        }
                    }
                    if (IsHeadcrab == false)
                    {
                        this.Nocollide(component1.gameObject);
                        Debug.Log((object)"attach");
                        this.Attach(component1);
                    }
                }
            }
            if (this.equipped && (double)collision.gameObject.GetComponent<Rigidbody2D>().velocity.x < (double)this.stabResistance && !(bool)(Object)component1)
            {
                this.transform.parent = component1.transform;
                this.GetComponent<Rigidbody2D>().isKinematic = true;
                this.GetComponent<FixedJoint2D>().enabled = false;
            }
            else
            {
                if (!this.equipped)
                    return;
                this.transform.parent = (Transform)null;
                this.GetComponent<Rigidbody2D>().isKinematic = false;
                this.GetComponent<FixedJoint2D>().enabled = true;
            }
        }

        private void OnCollisionExit2D(Collision2D collision)
        {
            if (!this.GetComponent<Rigidbody2D>().isKinematic)
                return;
            this.transform.parent = (Transform)null;
            this.GetComponent<Rigidbody2D>().isKinematic = false;
            this.GetComponent<FixedJoint2D>().enabled = true;
        }

        public void Nocollide(GameObject col)
        {
            NoCollide noCollide = this.gameObject.AddComponent<NoCollide>();
            noCollide.NoCollideSetA = this.GetComponents<Collider2D>();
            noCollide.NoCollideSetB = col.GetComponents<Collider2D>();
        }

        public void Attach(LimbBehaviour limb)
        {
            if (IsHeadcrab == true)
            {
                if (transform.GetComponent<NormalHeadcrabInfectionBehaviour>().IsHeadcrabTryingToTakeOver == false)
                {
                    if (IsNormalHeadcrab == true)
                    {
                        HeadcrabBackLegsSprite.sprite = MainModClass.HeadcrabAttachedSpriteBack;
                        transform.GetComponent<SpriteRenderer>().sprite = MainModClass.HeadcrabAttachedSprite;
                    }
                    if (IsPoisonHeadcrab == true)
                    {
                        HeadcrabBackLegsSprite.sprite = MainModClass.PoisonHeadcrabAttachedSpriteBack;
                        transform.GetComponent<SpriteRenderer>().sprite = MainModClass.PoisonHeadcrabAttachedSprite;
                    }
                    if (IsFastHeadcrab == true)
                    {
                        HeadcrabBackLegsSprite.sprite = MainModClass.FastHeadcrabAttachedSpriteBack;
                        transform.GetComponent<SpriteRenderer>().sprite = MainModClass.FastHeadcrabAttachedSprite;
                    }
                    if (IsSkulkcrab == true)
                    {
                        HeadcrabBackLegsSprite.sprite = MainModClass.SkulkcrabAttachedSpriteBack;
                        transform.GetComponent<SpriteRenderer>().sprite = MainModClass.SkulkcrabAttachedSprite;
                    }
                    transform.GetComponent<NormalHeadcrabInfectionBehaviour>().HeadcrabHost = limb.gameObject;
                    transform.GetComponent<NormalHeadcrabInfectionBehaviour>().IsHeadcrabTryingToTakeOver = true;
                    transform.gameObject.FixColliders();
                    transform.GetComponent<PhysicalBehaviour>().RefreshOutline();
                }
            }
            this.GetComponent<Rigidbody2D>().angularVelocity = 0.0f;
            SpriteRenderer component = this.GetComponent<SpriteRenderer>();
            component.sortingOrder = limb.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
            component.sortingLayerName = limb.gameObject.GetComponent<SpriteRenderer>().sortingLayerName;
            this.equipped = true;
            this.GetComponent<Rigidbody2D>().isKinematic = true;
            this.transform.parent = limb.transform;
            this.transform.localEulerAngles = new Vector3(0.0f, 0.0f, 0.0f);
            this.transform.localPosition = new Vector3(0.0f, 0.0f, 0.0f);
            this.transform.localScale = new Vector3(1f, 1f, 1f);
            this.transform.parent = (Transform)null;
            FixedJoint2D fixedJoint2D = this.gameObject.AddComponent<FixedJoint2D>();
            fixedJoint2D.dampingRatio = 1f;
            fixedJoint2D.frequency = 0.0f;
            fixedJoint2D.connectedBody = limb.GetComponent<Rigidbody2D>();
            this.GetComponent<Rigidbody2D>().isKinematic = false;
            this.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
            this.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
        }
    }

    public class ArmorIgnore : MonoBehaviour
    {
        private void OnCollisionEnter2D(Collision2D col)
        {
            ArmorBehaviour component = col.gameObject.GetComponent<ArmorBehaviour>();
            if (!(bool)(Object)component)
                return;
            component.Nocollide(this.gameObject);
        }
    }
}