using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class BioGrenadeHandler : MonoBehaviour
    {
        public bool GasRelease;
        public bool HasReleasedGas;

        private void Use()
        {
            if (GasRelease == false)
            {
                GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
                HuskAudioTransform1.transform.SetParent(this.transform);
                HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();

                AudioSource HuskTransformAudioClip = HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();
                float RandomPitch = UnityEngine.Random.Range(0.96f, 1.04f);
                HuskTransformAudioClip.pitch = RandomPitch;
                HuskTransformAudioClip.playOnAwake = false;
                HuskTransformAudioClip.minDistance = 8f;
                HuskTransformAudioClip.maxDistance = 30f;
                HuskTransformAudioClip.spatialBlend = 1f;
                HuskTransformAudioClip.clip = MainModClass.GrenadePin;
                HuskTransformAudioClip.Play();

                StartCoroutine(ReleaseTimer());
                GasRelease = true;
            }
        }
        public void Use(ActivationPropagation _)
        {
            if (GasRelease == false)
            {
                GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
                HuskAudioTransform1.transform.SetParent(this.transform);
                HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();

                AudioSource HuskTransformAudioClip = HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();
                float RandomPitch = UnityEngine.Random.Range(0.96f, 1.04f);
                HuskTransformAudioClip.pitch = RandomPitch;
                HuskTransformAudioClip.playOnAwake = false;
                HuskTransformAudioClip.minDistance = 8f;
                HuskTransformAudioClip.maxDistance = 30f;
                HuskTransformAudioClip.spatialBlend = 1f;
                HuskTransformAudioClip.clip = MainModClass.GrenadePin;
                HuskTransformAudioClip.Play();

                StartCoroutine(ReleaseTimer());
                GasRelease = true;
            }
        }

        public void Update()
        {
            if (GasRelease == true)
            {
                transform.GetComponent<SyringeBehaviour>().PressureMode = BloodContainer.PressureDirection.Pull;
            }
        }

        public IEnumerator ReleaseGas()
        {
            float Ranterns1 = UnityEngine.Random.Range(0.15f, 0.5f);
            int Ranterns0 = UnityEngine.Random.Range(0, 3);
            yield return new WaitForSeconds(Ranterns1);

            if (HasReleasedGas == false)
            {
                if (Ranterns0 == 0)
                {
                    SyringeExplosionBehaviour component = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                }
                if (Ranterns0 == 1)
                {
                    SyringeExplosionBehaviour component = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                    SyringeExplosionBehaviour component1 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component1.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component1.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component1.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                }
                if (Ranterns0 == 2)
                {
                    SyringeExplosionBehaviour component = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                    SyringeExplosionBehaviour component1 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component1.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component1.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component1.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                    SyringeExplosionBehaviour component2 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                    component2.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
                    component2.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
                    component2.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
                }
                StartCoroutine(ReleaseGas());
            }
        }
        public IEnumerator StopReleaseGas()
        {
            float Ranterns2 = UnityEngine.Random.Range(5f, 7.5f);
            yield return new WaitForSeconds(Ranterns2);

            HasReleasedGas = true;
            SyringeExplosionBehaviour component = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            SyringeExplosionBehaviour component1 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component1.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component1.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component1.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            SyringeExplosionBehaviour component2 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component2.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component2.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component2.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            SyringeExplosionBehaviour component4 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component4.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component4.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component4.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            SyringeExplosionBehaviour component15 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component15.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component15.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component15.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            SyringeExplosionBehaviour component26 = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
            component26.Colour = transform.GetComponent<SyringeBehaviour>().GetComputedColor();
            component26.Liquids = (IEnumerable<Liquid>)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Keys;
            component26.Amount = transform.GetComponent<SyringeBehaviour>().TotalLiquidAmount / (float)transform.GetComponent<SyringeBehaviour>().LiquidDistribution.Count;
            UnityEngine.Object.Destroy(transform.gameObject);
        }
        public IEnumerator ReleaseTimer()
        {
            float Ranterns21 = UnityEngine.Random.Range(4.5f, 5.5f);
            yield return new WaitForSeconds(Ranterns21);

            StartCoroutine(ReleaseGas());
            StartCoroutine(StopReleaseGas());
        }
    }
}