using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class NormalHeadcrabInfectionBehaviour : MonoBehaviour
    {
        public bool CanAttack = true;
        public bool IsSkulkcrab;
        public bool IsPoisonHeadcrab;
        public bool IsFastHeadcrab;
        public bool IsHeadcrabTryingToTakeOver;
        public GameObject HeadcrabHost;

        public bool HasInfectionStarted = false;
        public bool HasFullyTranformed = false;
        public GameObject HuskAudioIdle1Object;
        public bool ShouldPlayTransformationSound = false;
        public bool IsDead = false;

        void OnDestroy()
        {
            if(HeadcrabHost != null && HasFullyTranformed == true)
            {
                foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Health = 0f;
                    }
                }
            }
        }
        public IEnumerator Hand()
        {
            CanAttack = false;
            yield return new WaitForSeconds(0.75f);
            CanAttack = true;
        }
        public void OnCollisionEnter2D(Collision2D Collision)
        {
            if (HasFullyTranformed == false)
            {
                if (Collision.gameObject.GetComponent<LimbBehaviour>() == true)
                {
                    bool HasAlreadyHeadcrab = false;
                    foreach (Transform child in Collision.transform)
                    {
                        if (child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null && child.transform != transform)
                        {
                            HasAlreadyHeadcrab = true;
                        }
                    }
                    if (HasAlreadyHeadcrab == false)
                    {
                        if (Collision.gameObject.GetComponent<LimbBehaviour>().IsAndroid == false)
                        {
                            float RandomBiteStrenght = UnityEngine.Random.Range(20f, 125f);
                            int InfectionChance = UnityEngine.Random.Range(0, 5);
                            int RandomBiteAudio = UnityEngine.Random.Range(0, 2);
                            if (InfectionChance != 0)
                            {
                                foreach (LimbBehaviour x in Collision.transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                                {
                                    if (CanAttack == true)
                                    {
                                        Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght, (Vector3)Collision.contacts[0].point);
                                        if (RandomBiteAudio == 0)
                                        {
                                            Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght / 2.2f;
                                            Collision.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());

                                            GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                            gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.01f;
                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.05f;
                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.025f;
                                        }
                                        if (RandomBiteAudio == 1)
                                        {
                                            GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                            gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.01f;
                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.05f;
                                            x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.025f;

                                            Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght / 2.2f;
                                            Collision.gameObject.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                        }
                                        StartCoroutine(Hand());
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        public void Update()
        {
            transform.GetComponent<Rigidbody2D>().mass = 0.0485f;
            if (HeadcrabHost != null)
            {
                if (HasFullyTranformed == true)
                {
                    if (IsPoisonHeadcrab == false && IsFastHeadcrab == false)
                    {
                        foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                x.Person.ShockLevel -= 0.0125f;
                                x.Person.PainLevel -= 0.015f;
                            }
                        }
                    }
                    if (IsFastHeadcrab == true)
                    {
                        foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                x.Person.ShockLevel -= 0.0125f;
                                x.Person.PainLevel -= 0.015f;
                            }
                        }
                    }
                    if (IsPoisonHeadcrab == true)
                    {
                        foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                x.Person.ShockLevel -= 0.0125f;
                                x.Person.PainLevel -= 0.015f;
                                if (x.transform.gameObject.name == "UpperBody")
                                {
                                    x.Person.ShockLevel -= 0.0125f;
                                    x.Person.PainLevel -= 0.015f;
                                }
                                if (x.transform.gameObject.name == "MiddleBody")
                                {
                                    x.Person.ShockLevel -= 0.0125f;
                                    x.Person.PainLevel -= 0.015f;
                                }
                                if (x.transform.gameObject.name == "LowerBody")
                                {
                                    x.Person.ShockLevel -= 0.0125f;
                                    x.Person.PainLevel -= 0.015f;
                                }
                            }
                        }
                    }
                    if (IsDead == true)
                    {
                        if (HeadcrabHost.GetComponent<LimbBehaviour>().Health > 0)
                        {
                            IsDead = false;
                        }
                    }
                    if (IsDead == false)
                    {
                        foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                if (x.SkinMaterialHandler.RottenProgress > 0.45f || x.SkinMaterialHandler.RottenProgress == 0.45f)
                                {
                                    x.SkinMaterialHandler.RottenProgress = 0.45f;
                                }
                            }
                        }

                        if (HeadcrabHost.GetComponent<LimbBehaviour>().Health == 0 || HeadcrabHost.GetComponent<LimbBehaviour>().Health < 0)
                        {
                            int RandomIdleSound = UnityEngine.Random.Range(0, 2);
                            if (HeadcrabHost.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
                            {
                                if (RandomIdleSound == 0)
                                {
                                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                    HuskTransformAudioClip.pitch = RandomPitch;
                                    HuskTransformAudioClip.playOnAwake = false;
                                    HuskTransformAudioClip.minDistance = 3f;
                                    HuskTransformAudioClip.maxDistance = 20f;
                                    HuskTransformAudioClip.spatialBlend = 1.0f;
                                    HuskTransformAudioClip.clip = MainModClass.HuskDeadSound1;
                                    HuskTransformAudioClip.Play();
                                }
                                if (RandomIdleSound == 1)
                                {
                                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                    HuskTransformAudioClip.pitch = RandomPitch;
                                    HuskTransformAudioClip.playOnAwake = false;
                                    HuskTransformAudioClip.minDistance = 3f;
                                    HuskTransformAudioClip.maxDistance = 20f;
                                    HuskTransformAudioClip.spatialBlend = 1.0f;
                                    HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
                                    HuskTransformAudioClip.Play();
                                }
                            }
                            IsDead = true;
                        }
                    }
                }

                if (HasInfectionStarted == false)
                {                   
                    StartCoroutine(FirstRealSymptoms());
                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.BoneBreakClips).PickRandom<AudioClip>());
                    HasInfectionStarted = true;
                }
            }           
        }

        public IEnumerator IdleSounds()
        {
                float RandomTime = UnityEngine.Random.Range(7.5f, 30f);
                yield return new WaitForSeconds(RandomTime);

                int RandomIdleSound = UnityEngine.Random.Range(0, 3);

                if (transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
                {
                    if (RandomIdleSound == 0)
                    {
                        Debug.Log("1SoundIdle 1 and 2");
                        AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                        float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                        HuskTransformAudioClip.pitch = RandomPitch;
                        HuskTransformAudioClip.playOnAwake = false;
                        HuskTransformAudioClip.minDistance = 5f;
                        HuskTransformAudioClip.maxDistance = 20f;
                        HuskTransformAudioClip.spatialBlend = 1.0f;
                        HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                        HuskTransformAudioClip.Play();

                        float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
                        HuskTransformAudioClip.pitch = RandomPitch2;
                        HuskTransformAudioClip.playOnAwake = false;
                        HuskTransformAudioClip.minDistance = 5f;
                        HuskTransformAudioClip.maxDistance = 17.5f;
                        HuskTransformAudioClip.spatialBlend = 1.0f;
                        HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                        HuskTransformAudioClip.Play();
                    }
                    if (RandomIdleSound == 1)
                    {
                        Debug.Log("1SoundIdle 1");
                        AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                        float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                        HuskTransformAudioClip.pitch = RandomPitch;
                        HuskTransformAudioClip.playOnAwake = false;
                        HuskTransformAudioClip.minDistance = 5f;
                        HuskTransformAudioClip.maxDistance = 20f;
                        HuskTransformAudioClip.spatialBlend = 1.0f;
                        HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                        HuskTransformAudioClip.Play();
                    }
                    if (RandomIdleSound == 2)
                    {
                        Debug.Log("1SoundIdle 2");
                        AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                        float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                        HuskTransformAudioClip.pitch = RandomPitch;
                        HuskTransformAudioClip.playOnAwake = false;
                        HuskTransformAudioClip.minDistance = 5f;
                        HuskTransformAudioClip.maxDistance = 17.5f;
                        HuskTransformAudioClip.spatialBlend = 1.0f;
                        HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                        HuskTransformAudioClip.Play();
                    }
                }
                StartCoroutine(IdleSounds());
            
        }
        public IEnumerator FirstRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(3f, 5f);
            foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    if (x.transform.gameObject.name == "Head")
                    {
                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.95f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.5f;
                }
            }
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("1");
            foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.05f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.5f;
                }
            }
            StartCoroutine(SecondRealSymptoms());
        }

        public IEnumerator SecondRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(12.5f, 22.5f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("3");
            foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int Random = UnityEngine.Random.Range(0, 2);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = 0.1f;
                }
            }
            ShouldPlayTransformationSound = true;
            StartCoroutine(TransformationSoundTimer());
            StartCoroutine(LastRealSymptoms());
        }
        public IEnumerator LastRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(5f, 10f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("4");
            GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
            AudioSource HuskTransformAudioClip = HuskAudioTransform1.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip.pitch = RandomPitch;
            HuskTransformAudioClip.playOnAwake = false;
            HuskTransformAudioClip.minDistance = 5f;
            HuskTransformAudioClip.maxDistance = 25f;
            HuskTransformAudioClip.spatialBlend = 1.0f;
            HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
            HuskTransformAudioClip.Play();

            GameObject HuskAudioTransform10 = new GameObject("HuskAudioTransform2");
            AudioSource HuskTransformAudioClip0 = HuskAudioTransform10.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch1 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip0.pitch = RandomPitch1;
            HuskTransformAudioClip0.playOnAwake = false;
            HuskTransformAudioClip0.minDistance = 5f;
            HuskTransformAudioClip0.maxDistance = 80f;
            HuskTransformAudioClip0.spatialBlend = 1.0f;
            HuskTransformAudioClip0.clip = MainModClass.HuskTransformSound2;
            HuskTransformAudioClip0.Play();

            GameObject HuskAudioTransform100 = new GameObject("HuskAudioTransform3");
            AudioSource HuskTransformAudioClip00 = HuskAudioTransform100.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip00.pitch = RandomPitch2;
            HuskTransformAudioClip00.playOnAwake = false;
            HuskTransformAudioClip00.minDistance = 5f;
            HuskTransformAudioClip00.maxDistance = 55f;
            HuskTransformAudioClip00.spatialBlend = 1.0f;
            HuskTransformAudioClip00.clip = MainModClass.HuskTransformSound3;
            HuskTransformAudioClip00.Play();
            foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int RandomAmountTentacle1 = UnityEngine.Random.Range(0, 3);
                    int RandomAmountClawType1 = UnityEngine.Random.Range(0, 2);
                    int RandomChanceForClaws1 = UnityEngine.Random.Range(0, 2);

                    int RandomChanceForExtraArms1 = UnityEngine.Random.Range(0, 7);
                    int RandomExtraArmsType1 = UnityEngine.Random.Range(0, 3);

                    if (RandomAmountTentacle1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }

                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.ForceSetAllLiquid(0f);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.725f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.OxygenLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.AdrenalineLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth = 4f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BaseStrength *= 2.25f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Numbness = 0.75f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().IsZombie = true;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.InternalBleedingIntensity = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HealBone();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BodyTemperature = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().FreezingTemperature = -20f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().DiscomfortingHeatTemperature = 60f;
                    if (IsSkulkcrab == false)
                    {
                        x.transform.gameObject.GetComponent<LimbBehaviour>().RegenerationSpeed *= 5f;

                        x.transform.gameObject.GetComponent<LimbBehaviour>().BloodLiquidType = "HeadcrabBlood";
                    }
                    if (IsSkulkcrab == true)
                    {
                        x.transform.gameObject.GetComponent<LimbBehaviour>().RegenerationSpeed *= 7.5f;

                        x.transform.gameObject.GetComponent<LimbBehaviour>().BloodLiquidType = "SkulkcrabBlood";
                    }
                    double num = (double)x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType(), x.CirculationBehaviour.Limits.y);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BloodFlow = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BloodLossRateMultiplier *= 0.125f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate = 0.0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.IsPump = true;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasLungs = false;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasBrain = false;

                    if (RandomChanceForClaws1 != 0) 
                    {
                        if (x.transform.gameObject.name == "LowerArmFront")
                        {
                            if (IsPoisonHeadcrab == false && IsFastHeadcrab == false && IsSkulkcrab == false)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>();
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.HeadcrabClaw1;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.HeadcrabClaw2;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsSkulkcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().FastHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.SkulkcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.SkulkcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsFastHeadcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().FastHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.FastHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.FastHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsPoisonHeadcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().PoisonHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.PoisonHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.PoisonHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Foreground";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                        }
                        if (x.transform.gameObject.name == "LowerArm")
                        {
                            if (IsPoisonHeadcrab == false && IsFastHeadcrab == false && IsSkulkcrab == false)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>();
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.HeadcrabClaw1;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.HeadcrabClaw2;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsSkulkcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().FastHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.SkulkcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.SkulkcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsFastHeadcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().FastHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.FastHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.FastHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                            if (IsPoisonHeadcrab == true)
                            {
                                x.transform.gameObject.GetOrAddComponent<HeadcrabHand>().PoisonHeadcrab = true;
                                if (RandomAmountClawType1 == 0)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.PoisonHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                                if (RandomAmountClawType1 == 1)
                                {
                                    GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                    HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                    HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                    HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                    HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                    SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                    spriteRenderer.sprite = MainModClass.PoisonHeadcrabClaw;
                                    spriteRenderer.sortingLayerName = "Background";
                                    spriteRenderer.sortingOrder = 5;
                                }
                            }
                        }
                    }
                    if(RandomChanceForClaws1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                }
            }           
            ShouldPlayTransformationSound = false;
            StopCoroutine(TransformationSoundTimer());
            HasFullyTranformed = true;
        }
        public IEnumerator TransformationSoundTimer()
        {
            float RandomTime = UnityEngine.Random.Range(0.25f, 0.9f);
            int RandomSoundPlay = UnityEngine.Random.Range(0, 3);
            float RandomForceDirection = UnityEngine.Random.Range(-2.5f, 2.5f);
            yield return new WaitForSeconds(RandomTime);
            if (ShouldPlayTransformationSound == true)
            {
                if (RandomSoundPlay == 0)
                { 
                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.BoneBreakClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.15f, 2.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
                if (RandomSoundPlay == 1)
                {

                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.15f, 2.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
                if (RandomSoundPlay == 2)
                {
                    HeadcrabHost.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)HeadcrabHost.GetComponent<LimbBehaviour>().Person.BoneBreakClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in HeadcrabHost.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.15f, 2.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
            }
            StartCoroutine(TransformationSoundTimer());
        }

    }
}