using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class HuskInfectionBehaviour : MonoBehaviour
    {
        public bool HasInfectionStarted = false;
        public bool HasFullyTranformed = false;
        public GameObject HuskAudioIdle1Object;
        public bool ShouldPlayTransformationSound = false;
        public bool IsDead = false;
        public void Update()
        {

            if (HasFullyTranformed == true)
            {
                if (IsDead == true)
                {
                    if (transform.gameObject.GetComponent<LimbBehaviour>().Health > 0)
                    {
                        IsDead = false;
                    }
                }
                if (IsDead == false)
                {
                    foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        if (x.transform.GetComponent<LimbBehaviour>() == true)
                        {
                            if (x.SkinMaterialHandler.RottenProgress > 0.85f || x.SkinMaterialHandler.RottenProgress == 0.85f)
                            {
                                x.SkinMaterialHandler.RottenProgress = 0.85f;
                            }
                        }
                    }

                    if (transform.gameObject.GetComponent<LimbBehaviour>().Health == 0 || transform.gameObject.GetComponent<LimbBehaviour>().Health < 0)
                    {
                        int RandomIdleSound = UnityEngine.Random.Range(0, 2);
                        if (transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
                        {
                            if (RandomIdleSound == 0)
                            {
                                AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                HuskTransformAudioClip.pitch = RandomPitch;
                                HuskTransformAudioClip.playOnAwake = false;
                                HuskTransformAudioClip.minDistance = 3f;
                                HuskTransformAudioClip.maxDistance = 20f;
                                HuskTransformAudioClip.spatialBlend = 1.0f;
                                HuskTransformAudioClip.clip = MainModClass.HuskDeadSound1;
                                HuskTransformAudioClip.Play();
                            }
                            if (RandomIdleSound == 1)
                            {
                                AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                HuskTransformAudioClip.pitch = RandomPitch;
                                HuskTransformAudioClip.playOnAwake = false;
                                HuskTransformAudioClip.minDistance = 3f;
                                HuskTransformAudioClip.maxDistance = 20f;
                                HuskTransformAudioClip.spatialBlend = 1.0f;
                                HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
                                HuskTransformAudioClip.Play();
                            }
                        }
                        IsDead = true;
                    }
                }
            }
            if(HasInfectionStarted == false)
            {
                foreach (LimbBehaviour x in transform.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        if (x.transform.gameObject.name == "Head")
                        {
                            GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
                            HuskAudioTransform1.transform.position = x.transform.position;
                            HuskAudioTransform1.transform.SetParent(x.transform);
                            HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();
                            HuskAudioIdle1Object = HuskAudioTransform1;
                        }
                    }
                }

                transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>) transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.85f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0.1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0.1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.15f;
                    }
                }
                StartCoroutine(FirstRealSymptoms());
                HasInfectionStarted = true;
            }
        }

        public IEnumerator IdleSounds()
        {
            float RandomTime = UnityEngine.Random.Range(7.5f, 30f);
            yield return new WaitForSeconds(RandomTime);

            int RandomIdleSound = UnityEngine.Random.Range(0, 3);

            if (transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
            {
                if (RandomIdleSound == 0)
                {
                    Debug.Log("1SoundIdle 1 and 2");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 20f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                    HuskTransformAudioClip.Play();

                    float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch2;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 17.5f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                    HuskTransformAudioClip.Play();
                }
                if (RandomIdleSound == 1)
                {
                    Debug.Log("1SoundIdle 1");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 20f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                    HuskTransformAudioClip.Play();
                }
                if (RandomIdleSound == 2)
                {
                    Debug.Log("1SoundIdle 2");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 17.5f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                    HuskTransformAudioClip.Play();
                }
            }
            StartCoroutine(IdleSounds());
        }

        public void OnCollisionEnter2D(Collision2D Collision)
        {
            if (HasFullyTranformed == true && IsDead == false)
            {
                if (Collision.gameObject.GetComponent<LimbBehaviour>() == true)
                {
                    if (Collision.gameObject.GetComponent<LimbBehaviour>().IsAndroid == false)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(5f, 12.5f);
                        int RandomBiteAudio = UnityEngine.Random.Range(0,2);
                        foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.gameObject.ToString() == "Head" + " (UnityEngine.GameObject)")
                            {
                                if (x.gameObject.GetComponent<HuskCuredDebug>() == false)
                                {
                                    if (x.gameObject.GetComponent<HuskInfectionBehaviour>() == false)
                                    {
                                        x.gameObject.GetOrAddComponent<HuskInfectionBehaviour>();
                                    }
                                    if (x.gameObject.GetComponent<HuskInfectionBehaviour>().HasFullyTranformed == false || x.gameObject.GetComponent<HuskInfectionBehaviour>() == false)
                                    {
                                        Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght * 7.5f, (Vector3)Collision.contacts[0].point);
                                        if (RandomBiteAudio == 0)
                                        {
                                            transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                        }
                                        if (RandomBiteAudio == 1)
                                        {
                                            transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                        }
                                    }
                                }
                                if (x.gameObject.GetComponent<HuskCuredDebug>() == true)
                                {
                                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                                    {
                                        x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                        double num = (double)x.CirculationBehaviour.AddLiquid(transform.GetComponent<LimbBehaviour>().GetOriginalBloodType(), 0.75f);
                                        x.CirculationBehaviour.BloodFlow = 0.75f;
                                    }

                                    if (x.gameObject.GetComponent<HuskInfectionBehaviour>() == false)
                                    {
                                        x.gameObject.GetOrAddComponent<HuskInfectionBehaviour>();
                                    }
                                    if (x.gameObject.GetComponent<HuskInfectionBehaviour>().HasFullyTranformed == false || x.gameObject.GetComponent<HuskInfectionBehaviour>() == false)
                                    {
                                        Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght * 7.5f, (Vector3)Collision.contacts[0].point);

                                        if (RandomBiteAudio == 0)
                                        {
                                            transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                        }
                                        if (RandomBiteAudio == 1)
                                        {
                                            transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                        }
                                    }
                                    UnityEngine.Object.Destroy(transform.GetComponent<HuskCuredDebug>());
                                }
                            }
                        }
                    }
                }
            }
        }
        public IEnumerator FirstRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(2.5f, 5f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("1");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.65f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0.35f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0.35f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.25f;
                }
            }
            StartCoroutine(SecondRealSymptoms());
        }

        public IEnumerator SecondRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(1.5f, 8f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("2");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.35f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.5f;
                }
            }
            StartCoroutine(ThirdRealSymptoms());
        }
        public IEnumerator ThirdRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(2.5f, 10f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("3");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int Random = UnityEngine.Random.Range(0, 2);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = 0.1f;
                }
            }
            ShouldPlayTransformationSound = true;
            StartCoroutine(TransformationSoundTimer());
            StartCoroutine(LastRealSymptoms());
        }
        public IEnumerator LastRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(12.5f, 20f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("4");
            StartCoroutine(IdleSounds());
            GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
            AudioSource HuskTransformAudioClip = HuskAudioTransform1.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip.pitch = RandomPitch;
            HuskTransformAudioClip.playOnAwake = false;
            HuskTransformAudioClip.minDistance = 5f;
            HuskTransformAudioClip.maxDistance = 25f;
            HuskTransformAudioClip.spatialBlend = 1.0f;
            HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
            HuskTransformAudioClip.Play();

            GameObject HuskAudioTransform10 = new GameObject("HuskAudioTransform2");
            AudioSource HuskTransformAudioClip0 = HuskAudioTransform10.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch1 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip0.pitch = RandomPitch1;
            HuskTransformAudioClip0.playOnAwake = false;
            HuskTransformAudioClip0.minDistance = 5f;
            HuskTransformAudioClip0.maxDistance = 80f;
            HuskTransformAudioClip0.spatialBlend = 1.0f;
            HuskTransformAudioClip0.clip = MainModClass.HuskTransformSound2;
            HuskTransformAudioClip0.Play();

            GameObject HuskAudioTransform100 = new GameObject("HuskAudioTransform3");
            AudioSource HuskTransformAudioClip00 = HuskAudioTransform100.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip00.pitch = RandomPitch2;
            HuskTransformAudioClip00.playOnAwake = false;
            HuskTransformAudioClip00.minDistance = 5f;
            HuskTransformAudioClip00.maxDistance = 55f;
            HuskTransformAudioClip00.spatialBlend = 1.0f;
            HuskTransformAudioClip00.clip = MainModClass.HuskTransformSound3;
            HuskTransformAudioClip00.Play();
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int RandomAmountTentacle1 = UnityEngine.Random.Range(0, 3);
                    int RandomAmountClawType1 = UnityEngine.Random.Range(0, 3);
                    int RandomChanceForClaws1 = UnityEngine.Random.Range(0, 4);

                    int RandomChanceForExtraArms1 = UnityEngine.Random.Range(0, 5);
                    int RandomExtraArmsType1 = UnityEngine.Random.Range(0, 3);

                    if (RandomAmountTentacle1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }

                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.ForceSetAllLiquid(0f);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.725f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.OxygenLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.AdrenalineLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth = 3f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Numbness = 0.0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().IsZombie = true;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HealBone();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BodyTemperature = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().FreezingTemperature = -50f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().DiscomfortingHeatTemperature = 75f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BloodLiquidType = "VelonacepsCalyxBlood";
                    double num = (double)x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType(), x.CirculationBehaviour.Limits.y);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BloodLossRateMultiplier *= 0.125f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate = 0.0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.IsPump = true;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.InternalBleedingIntensity = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasLungs = false;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasBrain = false;

                    if(RandomChanceForExtraArms1 == 0)
                    {
                        if (x.transform.gameObject.name == "UpperArmFront")
                        {
                            if (RandomExtraArmsType1 == 0)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm1;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomExtraArmsType1 == 1)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm2;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomExtraArmsType1 == 2)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm3;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }
                        }
                        if (x.transform.gameObject.name == "UpperArm")
                        {
                            if (RandomExtraArmsType1 == 0)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm1;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomExtraArmsType1 == 1)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm2;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomExtraArmsType1 == 2)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.ExtraArm3;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                        }
                    }
                    if (RandomChanceForClaws1 != 0) 
                    {
                        if (x.transform.gameObject.name == "LowerArmFront")
                        {
                            x.transform.gameObject.GetOrAddComponent<HuskHandInfectionHandler>();
                            if (RandomAmountClawType1 == 0)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw1;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomAmountClawType1 == 1)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw2;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomAmountClawType1 == 2)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw3;
                                spriteRenderer.sortingLayerName = "Foreground";
                                spriteRenderer.sortingOrder = 5;
                            }

                        }
                        if (x.transform.gameObject.name == "LowerArm")
                        {
                            x.transform.gameObject.GetOrAddComponent<HuskHandInfectionHandler>();
                            if (RandomAmountClawType1 == 0)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw1;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomAmountClawType1 == 1)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw2;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                            if (RandomAmountClawType1 == 2)
                            {
                                GameObject HuskInfectionHandClawAnomaly = new GameObject("HuskInfectionHandClawAnomaly");
                                HuskInfectionHandClawAnomaly.transform.position = x.transform.position;
                                HuskInfectionHandClawAnomaly.transform.SetParent(x.transform);
                                HuskInfectionHandClawAnomaly.transform.rotation = x.transform.rotation;
                                HuskInfectionHandClawAnomaly.transform.localScale = new Vector3(1f, 1f);
                                SpriteRenderer spriteRenderer = HuskInfectionHandClawAnomaly.AddComponent<SpriteRenderer>();
                                spriteRenderer.sprite = MainModClass.Claw3;
                                spriteRenderer.sortingLayerName = "Background";
                                spriteRenderer.sortingOrder = 5;
                            }
                        }
                    }
                    if(RandomChanceForClaws1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                }
            }

            int RandomFace = UnityEngine.Random.Range(0, 5);
            if(RandomFace == 0)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("HuskInfectionFaceAnomaly");
                HuskInfectionFaceAnomaly.transform.position = transform.position;
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.HuskInfectionFaceAnomaly1;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;

                GameObject HuskInfectionFaceAnomalyEyes = new GameObject("HuskInfectionFaceAnomalyEyes");
                HuskInfectionFaceAnomalyEyes.transform.position = transform.position;
                HuskInfectionFaceAnomalyEyes.transform.SetParent(this.transform);
                HuskInfectionFaceAnomalyEyes.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomalyEyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer1 = HuskInfectionFaceAnomalyEyes.AddComponent<SpriteRenderer>();
                spriteRenderer1.sprite = MainModClass.HuskInfectionFaceAnomalyEyes1;
                spriteRenderer1.gameObject.AddComponent<IfHeadDeadBehaviour>();
                spriteRenderer1.sortingLayerName = "Foreground";
                spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                spriteRenderer1.sortingOrder = 2;
            }
            if (RandomFace == 1)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("HuskInfectionFaceAnomaly");
                HuskInfectionFaceAnomaly.transform.position = transform.position;
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.HuskInfectionFaceAnomaly2;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;

                GameObject HuskInfectionFaceAnomalyEyes = new GameObject("HuskInfectionFaceAnomalyEyes");
                HuskInfectionFaceAnomalyEyes.transform.position = transform.position;
                HuskInfectionFaceAnomalyEyes.transform.SetParent(this.transform);
                HuskInfectionFaceAnomalyEyes.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomalyEyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer1 = HuskInfectionFaceAnomalyEyes.AddComponent<SpriteRenderer>();
                spriteRenderer1.sprite = MainModClass.HuskInfectionFaceAnomalyEyes2;
                spriteRenderer1.gameObject.AddComponent<IfHeadDeadBehaviour>();
                spriteRenderer1.sortingLayerName = "Foreground";
                spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                spriteRenderer1.sortingOrder = 2;
            }
            if (RandomFace == 2)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("HuskInfectionFaceAnomaly");
                HuskInfectionFaceAnomaly.transform.position = transform.position;
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.HuskInfectionFaceAnomaly3;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;

                GameObject HuskInfectionFaceAnomalyEyes = new GameObject("HuskInfectionFaceAnomalyEyes");
                HuskInfectionFaceAnomalyEyes.transform.position = transform.position;
                HuskInfectionFaceAnomalyEyes.transform.SetParent(this.transform);
                HuskInfectionFaceAnomalyEyes.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomalyEyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer1 = HuskInfectionFaceAnomalyEyes.AddComponent<SpriteRenderer>();
                spriteRenderer1.sprite = MainModClass.HuskInfectionFaceAnomalyEyes3;
                spriteRenderer1.gameObject.AddComponent<IfHeadDeadBehaviour>();
                spriteRenderer1.sortingLayerName = "Foreground";
                spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                spriteRenderer1.sortingOrder = 2;
            }
            if (RandomFace == 3)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("HuskInfectionFaceAnomaly");
                HuskInfectionFaceAnomaly.transform.position = transform.position;
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.HuskInfectionFaceAnomaly4;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;

                GameObject HuskInfectionFaceAnomalyEyes = new GameObject("HuskInfectionFaceAnomalyEyes");
                HuskInfectionFaceAnomalyEyes.transform.position = transform.position;
                HuskInfectionFaceAnomalyEyes.transform.SetParent(this.transform);
                HuskInfectionFaceAnomalyEyes.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomalyEyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer1 = HuskInfectionFaceAnomalyEyes.AddComponent<SpriteRenderer>();
                spriteRenderer1.sprite = MainModClass.HuskInfectionFaceAnomalyEyes4;
                spriteRenderer1.gameObject.AddComponent<IfHeadDeadBehaviour>();
                spriteRenderer1.sortingLayerName = "Foreground";
                spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                spriteRenderer1.sortingOrder = 2;
            }
            if (RandomFace == 4)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("HuskInfectionFaceAnomaly");
                HuskInfectionFaceAnomaly.transform.position = transform.position;
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.HuskInfectionFaceAnomaly5;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;

                GameObject HuskInfectionFaceAnomalyEyes = new GameObject("HuskInfectionFaceAnomalyEyes");
                HuskInfectionFaceAnomalyEyes.transform.position = transform.position;
                HuskInfectionFaceAnomalyEyes.transform.SetParent(this.transform);
                HuskInfectionFaceAnomalyEyes.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomalyEyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer1 = HuskInfectionFaceAnomalyEyes.AddComponent<SpriteRenderer>();
                spriteRenderer1.sprite = MainModClass.HuskInfectionFaceAnomalyEyes5;
                spriteRenderer1.gameObject.AddComponent<IfHeadDeadBehaviour>();
                spriteRenderer1.sortingLayerName = "Foreground";
                spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                spriteRenderer1.sortingOrder = 2;
            }
            int TentacleCount = UnityEngine.Random.Range(0, 4);

            if (TentacleCount == 0)
            {

            }
            if (TentacleCount == 1)
            {
                GameObject HuskInfectionFaceTentacle1 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle1.transform.position = transform.position;
                HuskInfectionFaceTentacle1.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle1.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle1.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceTentacle1.AddComponent<SpriteRenderer>();
                int TentacleSprite1 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite1 == 0)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite1 == 1)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite1 == 2)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer.sortingLayerName = "Background";
                spriteRenderer.sortingOrder = 2;
                HuskInfectionFaceTentacle1.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle1.GetComponent<HuskTentacleHandler>().MiddleTentacle = true;
            }
            if (TentacleCount == 2)
            {
                GameObject HuskInfectionFaceTentacle1 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle1.transform.position = transform.position;
                HuskInfectionFaceTentacle1.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle1.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle1.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceTentacle1.AddComponent<SpriteRenderer>();
                int TentacleSprite1 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite1 == 0)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite1 == 1)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite1 == 2)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer.sortingLayerName = "Background";
                spriteRenderer.sortingOrder = 2;
                HuskInfectionFaceTentacle1.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle1.GetComponent<HuskTentacleHandler>().UpTentacle = true;

                GameObject HuskInfectionFaceTentacle10 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle10.transform.position = transform.position;
                HuskInfectionFaceTentacle10.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle10.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle10.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer0 = HuskInfectionFaceTentacle10.AddComponent<SpriteRenderer>();
                int TentacleSprite10 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite10 == 0)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite10 == 1)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite10 == 2)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer0.sortingLayerName = "Background";
                spriteRenderer0.sortingOrder = 2;
                HuskInfectionFaceTentacle10.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle10.GetComponent<HuskTentacleHandler>().DownTentacle = true;
            }
            if (TentacleCount == 3)
            {
                GameObject HuskInfectionFaceTentacle1 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle1.transform.position = transform.position;
                HuskInfectionFaceTentacle1.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle1.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle1.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceTentacle1.AddComponent<SpriteRenderer>();

                int TentacleSprite1 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite1 == 0)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite1 == 1)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite1 == 2)
                {
                    spriteRenderer.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer.sortingLayerName = "Background";
                spriteRenderer.sortingOrder = 2;
                HuskInfectionFaceTentacle1.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle1.GetComponent<HuskTentacleHandler>().MiddleTentacle = true;

                GameObject HuskInfectionFaceTentacle11 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle11.transform.position = transform.position;
                HuskInfectionFaceTentacle11.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle11.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle11.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer11 = HuskInfectionFaceTentacle11.AddComponent<SpriteRenderer>();
                int TentacleSprite11 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite11 == 0)
                {
                    spriteRenderer11.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite11 == 1)
                {
                    spriteRenderer11.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite11 == 2)
                {
                    spriteRenderer11.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer11.sortingLayerName = "Background";
                spriteRenderer11.sortingOrder = 2;
                HuskInfectionFaceTentacle11.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle11.GetComponent<HuskTentacleHandler>().UpTentacle = true;

                GameObject HuskInfectionFaceTentacle10 = new GameObject("HuskInfectionFaceTentacle");
                HuskInfectionFaceTentacle10.transform.position = transform.position;
                HuskInfectionFaceTentacle10.transform.SetParent(this.transform);
                HuskInfectionFaceTentacle10.transform.rotation = transform.rotation;
                HuskInfectionFaceTentacle10.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer0 = HuskInfectionFaceTentacle10.AddComponent<SpriteRenderer>();
                int TentacleSprite100 = UnityEngine.Random.Range(0, 3);

                if (TentacleSprite100 == 0)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle1;
                }
                if (TentacleSprite100 == 1)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle2;
                }
                if (TentacleSprite100 == 2)
                {
                    spriteRenderer0.sprite = MainModClass.Tentacle3;
                }
                spriteRenderer0.sortingLayerName = "Background";
                spriteRenderer0.sortingOrder = 2;
                HuskInfectionFaceTentacle10.AddComponent<HuskTentacleHandler>();
                HuskInfectionFaceTentacle10.GetComponent<HuskTentacleHandler>().DownTentacle = true;
            }


            ShouldPlayTransformationSound = false;
            StopCoroutine(TransformationSoundTimer());
            HasFullyTranformed = true;
        }
        public IEnumerator TransformationSoundTimer()
        {
            float RandomTime = UnityEngine.Random.Range(0.25f, 0.9f);
            int RandomSoundPlay = UnityEngine.Random.Range(0, 3);
            float RandomForceDirection = UnityEngine.Random.Range(-2.5f, 2.5f);
            yield return new WaitForSeconds(RandomTime);
            if (ShouldPlayTransformationSound == true)
            {
                if (RandomSoundPlay == 0)
                { 
                    transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                    transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.BoneBreakClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.25f, 3.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
                if (RandomSoundPlay == 1)
                {

                    transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.25f, 3.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
                if (RandomSoundPlay == 2)
                {
                    transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.BoneBreakClips).PickRandom<AudioClip>());
                    foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        float RandomForce = UnityEngine.Random.Range(0.25f, 3.5f);
                        if (x.transform.GetComponent<Rigidbody2D>() == true)
                        {
                            x.transform.GetComponent<Rigidbody2D>().AddForce(new Vector2(RandomForceDirection, RandomForce));
                        }
                    }
                }
            }
            StartCoroutine(TransformationSoundTimer());
        }

    }
}