using System.Collections;
using UnityEngine;

    public class IfHeadDeadBehaviour : MonoBehaviour
    {
        private LimbBehaviour head;
        private bool fading;
        private bool dead;
        private IEnumerator coroutine;

        private void Start() => this.head = this.GetComponentInParent<LimbBehaviour>();

        private void Update()
        {
            if ((double)this.head.Health <= 0.0 && !this.dead && !this.fading)
            {
                this.coroutine = this.Fade(1, 0, 0.05f);
                this.StartCoroutine(this.coroutine);
                this.fading = true;
                this.dead = true;
            }
            if ((double)this.head.Health <= 0.0 || !this.dead || this.fading)
                return;
            this.coroutine = this.Fade(0, 1, -0.1f);
            this.StartCoroutine(this.coroutine);
            this.fading = true;
            this.dead = false;
        }

        private IEnumerator Fade(int start, int goal, float rate)
        {
            for (float I = (float)start; (double)I != (double)goal; I -= rate)
            {
                this.fading = true;
                if (goal == 0 && (double)I <= 0.100000001490116)
                {
                    I = 0.0f;
                    this.fading = false;
                    Color col1 = this.GetComponent<SpriteRenderer>().color;
                    col1.a = 0.0f;
                    this.GetComponent<SpriteRenderer>().color = col1;
                    this.StopCoroutine(this.coroutine);
                    col1 = new Color();
                }
                if (goal == 1 && (double)I >= 0.949999988079071)
                {
                    I = 1f;
                    this.fading = false;
                    Color col2 = this.GetComponent<SpriteRenderer>().color;
                    col2.a = 1f;
                    this.GetComponent<SpriteRenderer>().color = col2;
                    this.StopCoroutine(this.coroutine);
                    col2 = new Color();
                }
                Color col = this.GetComponent<SpriteRenderer>().color;
                col.a = I;
                col.r = I;
                col.b = I;
                col.g = I;
                this.GetComponent<SpriteRenderer>().color = col;
                yield return (object)null;
                col = new Color();
            }
        }
    }
