using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ManipulatorDeviceBehaviour : MonoBehaviour
    {

        private LineRenderer LR;
        public bool IsGravityMassManipulatorDevice = false;
        public float SettedMass = 0f;

        public bool IsTemperatureManipulatorDevice = false;
        public float SettedTemperature = 0f;

        public bool IsColourManipulatorDevice = false;
        public Color SettedColour = new Color(1f, 1f, 1f);


        private void Awake()
        {
            this.LR = this.gameObject.AddComponent<LineRenderer>();
            this.LR.startWidth = 0.05f;
            this.LR.endWidth = 0.05f;
            this.LR.material = UnityEngine.Object.Instantiate<Material>(ModAPI.FindMaterial("VeryBright"));
            this.LR.material.mainTexture = ModAPI.LoadTexture("Textures/Beam.png");
            this.LR.sortingOrder = -5;
            this.LR.sortingLayerID = this.gameObject.GetComponent<SpriteRenderer>().sortingLayerID;
        }
        #region FireDevice 
        public void FireDevice()
        {
            if (IsColourManipulatorDevice == true)
            {
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);

                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    Color color = new Color(1f, 1f, 1f);

                    float RandomColor1 = UnityEngine.Random.Range(0.00f, 1.00f);
                    float RandomColor2 = UnityEngine.Random.Range(0.00f, 1.00f);
                    float RandomColor3 = UnityEngine.Random.Range(0.00f, 1.00f);

                    LR.enabled = true;
                    LR.startColor = new Color(SettedColour.r, SettedColour.g, SettedColour.b, 1f);
                    LR.endColor = new Color(SettedColour.r, SettedColour.g, SettedColour.b, 1f);
                    LR.material.SetColor("_GlowColour", new Color(SettedColour.r, SettedColour.g, SettedColour.b, 0.3f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (SpriteRenderer TargetedSpriteRenderer in hit.transform.root.gameObject.GetComponentsInChildren<SpriteRenderer>())
                        {
                            TargetedSpriteRenderer.GetComponent<SpriteRenderer>().color = new Color(SettedColour.r, SettedColour.g, SettedColour.b, 1f);
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        LR.startColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                        LR.endColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                        LR.material.SetColor("_GlowColour", new Color(RandomColor1, RandomColor2, RandomColor3, 0.3f));
                        if (hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                        {
                            foreach (SpriteRenderer TargetedSpriteRenderer in hit.transform.root.gameObject.GetComponentsInChildren<SpriteRenderer>())
                            {
                                TargetedSpriteRenderer.GetComponent<SpriteRenderer>().color = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                            }
                        }

                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f)
                    {
                        LR.startColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                        LR.endColor = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                        LR.material.SetColor("_GlowColour", new Color(RandomColor1, RandomColor2, RandomColor3, 0.3f));

                        if (hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                        {
                            foreach (SpriteRenderer TargetedSpriteRenderer in hit.transform.root.gameObject.GetComponentsInChildren<SpriteRenderer>())
                            {
                                TargetedSpriteRenderer.GetComponent<SpriteRenderer>().color = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);
                                TargetedSpriteRenderer.transform.gameObject.AddComponent<ExtremeColorChanger>();
                            }
                        }
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsTemperatureManipulatorDevice == true)
            {
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                
                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    float RandomTemperature = UnityEngine.Random.Range(-1000.00f, 1000.00f);
                    int RandomExtremeTemperature = UnityEngine.Random.Range(1, 3);

                    LR.enabled = true;
                    LR.startColor = new Color(1f, 1f, 0f, 1f);
                    LR.endColor = new Color(1f, 1f, 0f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(1f, 1f, 0f, 1f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().Temperature = SettedTemperature;
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().Temperature = RandomTemperature;
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        if (RandomExtremeTemperature == 1)
                        {
                            foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                            {
                                TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
                                TargetedPhysicalBehaviour.transform.gameObject.GetOrAddComponent<GlowingHotMetalBehaviour>();
                                TargetedPhysicalBehaviour.transform.gameObject.GetOrAddComponent<ExtremeTemperatureHandler>().Hot = true;
                                TargetedPhysicalBehaviour.transform.gameObject.GetComponent<ExtremeTemperatureHandler>().Cold = false;
                            }
                        }
                        if (RandomExtremeTemperature == 2)
                        {
                            foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                            {
                                TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Ice");
                                TargetedPhysicalBehaviour.transform.gameObject.GetOrAddComponent<GlowingHotMetalBehaviour>();
                                TargetedPhysicalBehaviour.transform.gameObject.GetOrAddComponent<ExtremeTemperatureHandler>().Cold = true;
                                TargetedPhysicalBehaviour.transform.gameObject.GetComponent<ExtremeTemperatureHandler>().Hot = false;
                            }   
                        } 
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
            if (IsGravityMassManipulatorDevice == true)
            {
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);
                UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().DeleteEffect, transform.position, Quaternion.identity);

                RaycastHit2D hit = Physics2D.Raycast(transform.position, (Vector2)((double)this.transform.lossyScale.x > 0.0 ? this.transform.right : -this.transform.right), 10000f, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
                if (hit != null)
                {
                    float RandomMass = UnityEngine.Random.Range(-100.00f, 100.00f);

                    LR.enabled = true;
                    LR.startColor = new Color(0f, 1f, 0f, 1f);
                    LR.endColor = new Color(0f, 1f, 0f, 1f);
                    LR.material.SetColor("_GlowColour", new Color(0f, 1f, 0f, 1f));
                    LR.material.SetFloat("_GlowIntensity", 0.3f);
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, hit.point);
                    StartCoroutine(LineRendererDisabler());
                    CameraShakeBehaviour.main.Shake(1f, (Vector2)this.transform.position, 1f);
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 50.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().rigidbody.mass = SettedMass;
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = SettedMass / 2;
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 50.0f && gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge <= 500.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().rigidbody.mass = RandomMass;
                            TargetedPhysicalBehaviour.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = RandomMass / 2;
                        }
                    }
                    if (gameObject.transform.parent.GetComponent<PhysicalBehaviour>().charge >= 500.0f && hit.transform.gameObject.GetComponent<PhysicalBehaviour>().Deletable == true)
                    {
                        foreach (PhysicalBehaviour TargetedPhysicalBehaviour in hit.transform.root.gameObject.GetComponentsInChildren<PhysicalBehaviour>())
                        {
                            TargetedPhysicalBehaviour.transform.gameObject.GetOrAddComponent<ExtremeMassHandler>();
                        }                     
                    }
                }
                else
                {
                    LR.enabled = false;
                    LR.SetPosition(0, transform.position);
                    LR.SetPosition(1, transform.position);
                }
            }
        }
        #endregion

        public IEnumerator LineRendererDisabler()
        {
            yield return (object)new WaitForSeconds(0.15f);
            LR.enabled = false;
        }
    }
}