using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ManipulatorDeviceHandler : MonoBehaviour
    {
        public Color SetColour = new Color(1f, 1f, 1f);
        public float SetTemperature = 0f;
        public float SetMass = 0f;

        private void Use()
        {
            gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().FireDevice();
        }
        public void Use(ActivationPropagation _)
        {
            gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().FireDevice();
        }

        public void Start()
        {
            if (gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().IsColourManipulatorDevice == true)
            {
                ColorSetterSetup();
            }
            if (gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().IsTemperatureManipulatorDevice == true)
            {
                TemperatureSetterSetup();
            }
            if (gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().IsGravityMassManipulatorDevice == true)
            {
                GravitySetterSetup();
            }
        }

        public void ColorSetterSetup()
        {
                gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("selectbutt", "Set Target Color", "Change the Color in which Objects should be painted in", new UnityAction[1]
                  {
              (UnityAction) (() =>
              {
               DialogBox dialog = (DialogBox)null;
               dialog = DialogBoxManager.TextEntry("Change the Color by using the following format: R,G,B. Values can reach from 0.00 to 1.00", "Red, Green, Blue", new DialogButton("Set Target Color", true, new UnityAction[1]
               {
                 (UnityAction) (() =>
                   {
                      if (dialog.EnteredText != "")
                      {
                string[] strArray = dialog.EnteredText.Split(","[0]);
                ModAPI.Notify((object) ("Color successfully set to " + dialog.EnteredText));

                this.SetColour.r = float.Parse(strArray[0]);
                this.SetColour.g = float.Parse(strArray[1]);
                this.SetColour.b = float.Parse(strArray[2]);
                gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().SettedColour = this.SetColour;
                       }
              else
                ModAPI.Notify((object) "Color Couldn't be set to that value. Have you typed everything correctly?");
            })
          }), new DialogButton("Cancel", true, new UnityAction[1]
          {
            (UnityAction) (() => dialog.Close())
          }));
        })
                  }));
            
        }

        public void TemperatureSetterSetup()
        {
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("selectbutt", "Set Target Temperature", "Change the Temperature in which targeted Objects should be setted to", new UnityAction[1]
              {
              (UnityAction) (() =>
              {
               DialogBox dialog = (DialogBox)null;
               dialog = DialogBoxManager.TextEntry("Change the Temperature by typing any number from negative Infintiy to like positive Infinity", "Temperature", new DialogButton("Set Target Temperature", true, new UnityAction[1]
               {
                 (UnityAction) (() =>
                   {
                      if (dialog.EnteredText != "")
                      {
                string[] strArray = dialog.EnteredText.Split(","[0]);
                ModAPI.Notify((object) ("Temperature successfully set to " + dialog.EnteredText));

                this.SetTemperature = float.Parse(strArray[0]);
                gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().SettedTemperature = this.SetTemperature;
                       }
              else
                ModAPI.Notify((object) "Temperature Couldn't be set to that value. Have you typed everything correctly?");
            })
          }), new DialogButton("Cancel", true, new UnityAction[1]
          {
            (UnityAction) (() => dialog.Close())
          }));
        })
              }));

        }
        public void GravitySetterSetup()
        {
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("selectbutt", "Set Target Mass", "Change the Mass in which targeted Objects should be setted to", new UnityAction[1]
              {
              (UnityAction) (() =>
              {
               DialogBox dialog = (DialogBox)null;
               dialog = DialogBoxManager.TextEntry("Change the Mass by typing any number from negative Infintiy to like positive Infinity", "Mass", new DialogButton("Set Target Mass", true, new UnityAction[1]
               {
                 (UnityAction) (() =>
                   {
                      if (dialog.EnteredText != "")
                      {
                string[] strArray = dialog.EnteredText.Split(","[0]);
                ModAPI.Notify((object) ("Mass successfully set to " + dialog.EnteredText));

                this.SetMass = float.Parse(strArray[0]);
                gameObject.GetComponentInChildren<ManipulatorDeviceBehaviour>().SettedMass = this.SetMass;
                       }
              else
                ModAPI.Notify((object) "Mass Couldn't be set to that value. Have you typed everything correctly?");
            })
          }), new DialogButton("Cancel", true, new UnityAction[1]
          {
            (UnityAction) (() => dialog.Close())
          }));
        })
              }));

        }
    }
}