using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class TEARSPlagueInfectionBehaviour : MonoBehaviour
    {
        public bool HasInfectionStarted = false;
        public bool HasFullyTranformed = false;
        public GameObject HuskAudioIdle1Object;
        public bool ShouldPlayTransformationSound = false;
        public bool IsDead = false;
        public void Update()
        {

            if (HasFullyTranformed == true)
            {
                if (IsDead == true)
                {
                    if (transform.gameObject.GetComponent<LimbBehaviour>().Health > 0)
                    {
                        IsDead = false;
                    }
                }
                if (IsDead == false)
                {
                    foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        if (x.transform.GetComponent<LimbBehaviour>() == true)
                        {
                            if (x.SkinMaterialHandler.RottenProgress > 0.35f || x.SkinMaterialHandler.RottenProgress == 0.35f)
                            {
                                x.SkinMaterialHandler.RottenProgress = 0.35f;
                            }
                        }
                    }

                    if (transform.gameObject.GetComponent<LimbBehaviour>().Health == 0 || transform.gameObject.GetComponent<LimbBehaviour>().Health < 0)
                    {
                        int RandomIdleSound = UnityEngine.Random.Range(0, 2);
                        if (transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
                        {
                            if (RandomIdleSound == 0)
                            {
                                AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                HuskTransformAudioClip.pitch = RandomPitch;
                                HuskTransformAudioClip.playOnAwake = false;
                                HuskTransformAudioClip.minDistance = 3f;
                                HuskTransformAudioClip.maxDistance = 20f;
                                HuskTransformAudioClip.spatialBlend = 1.0f;
                                HuskTransformAudioClip.clip = MainModClass.HuskDeadSound1;
                                HuskTransformAudioClip.Play();
                            }
                            if (RandomIdleSound == 1)
                            {
                                AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                                float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                                HuskTransformAudioClip.pitch = RandomPitch;
                                HuskTransformAudioClip.playOnAwake = false;
                                HuskTransformAudioClip.minDistance = 3f;
                                HuskTransformAudioClip.maxDistance = 20f;
                                HuskTransformAudioClip.spatialBlend = 1.0f;
                                HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
                                HuskTransformAudioClip.Play();
                            }
                        }
                        IsDead = true;
                    }
                }
            }
            if(HasInfectionStarted == false)
            {
                foreach (LimbBehaviour x in transform.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        if (x.transform.gameObject.name == "Head")
                        {
                            GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
                            HuskAudioTransform1.transform.position = x.transform.position;
                            HuskAudioTransform1.transform.SetParent(x.transform);
                            HuskAudioTransform1.transform.gameObject.GetOrAddComponent<AudioSource>();
                            HuskAudioIdle1Object = HuskAudioTransform1;
                        }
                    }
                }

                transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>) transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.95f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0.1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0.1f;
                        x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.15f;
                    }
                }
                StartCoroutine(FirstRealSymptoms());
                HasInfectionStarted = true;
            }
        }

        public IEnumerator IdleSounds()
        {
            float RandomTime = UnityEngine.Random.Range(7.5f, 30f);
            yield return new WaitForSeconds(RandomTime);

            int RandomIdleSound = UnityEngine.Random.Range(0, 3);

            if (transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness > 0.85f)
            {
                if (RandomIdleSound == 0)
                {
                    Debug.Log("1SoundIdle 1 and 2");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 20f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                    HuskTransformAudioClip.Play();

                    float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch2;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 17.5f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                    HuskTransformAudioClip.Play();
                }
                if (RandomIdleSound == 1)
                {
                    Debug.Log("1SoundIdle 1");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 20f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound1;
                    HuskTransformAudioClip.Play();
                }
                if (RandomIdleSound == 2)
                {
                    Debug.Log("1SoundIdle 2");
                    AudioSource HuskTransformAudioClip = HuskAudioIdle1Object.transform.gameObject.GetOrAddComponent<AudioSource>();
                    float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
                    HuskTransformAudioClip.pitch = RandomPitch;
                    HuskTransformAudioClip.playOnAwake = false;
                    HuskTransformAudioClip.minDistance = 5f;
                    HuskTransformAudioClip.maxDistance = 17.5f;
                    HuskTransformAudioClip.spatialBlend = 1.0f;
                    HuskTransformAudioClip.clip = MainModClass.HuskIdleSound2;
                    HuskTransformAudioClip.Play();
                }
            }
            StartCoroutine(IdleSounds());
        }

        public void OnCollisionEnter2D(Collision2D Collision)
        {
            if (HasFullyTranformed == true && IsDead == false)
            {
                if (Collision.gameObject.GetComponent<LimbBehaviour>() == true)
                {
                    if (Collision.gameObject.GetComponent<LimbBehaviour>().IsAndroid == false)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(5f, 12.5f);
                        int RandomBiteAudio = UnityEngine.Random.Range(0,2);
                        foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            if (x.gameObject.ToString() == "Head" + " (UnityEngine.GameObject)")
                            {
                                if (x.gameObject.GetComponent<ZombieCuredDebug>() == false)
                                {
                                    if (x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == false)
                                    {
                                        x.gameObject.GetOrAddComponent<TEARSPlagueInfectionBehaviour>();
                                    }
                                    if (x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>().HasFullyTranformed == false || x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == false)
                                    {
                                        Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght * 6, (Vector3)Collision.contacts[0].point);
                                        if (RandomBiteAudio == 0)
                                        {
                                            transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                        }
                                        if (RandomBiteAudio == 1)
                                        {
                                            transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                        }
                                    }
                                }
                                if (x.gameObject.GetComponent<ZombieCuredDebug>() == true)
                                {
                                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                                    {
                                        x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                        double num = (double)x.CirculationBehaviour.AddLiquid(transform.GetComponent<LimbBehaviour>().GetOriginalBloodType(), 0.75f);
                                        x.CirculationBehaviour.BloodFlow = 0.75f;
                                    }

                                    if (x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == false)
                                    {
                                        x.gameObject.GetOrAddComponent<TEARSPlagueInfectionBehaviour>();
                                    }
                                    if (x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>().HasFullyTranformed == false || x.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == false)
                                    {
                                        Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght * 6, (Vector3)Collision.contacts[0].point);

                                        if (RandomBiteAudio == 0)
                                        {
                                            transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                        }
                                        if (RandomBiteAudio == 1)
                                        {
                                            transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                        }
                                    }
                                    UnityEngine.Object.Destroy(transform.GetComponent<ZombieCuredDebug>());
                                }
                            }
                        }
                    }
                }
            }
        }
        public IEnumerator FirstRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(5f, 12.5f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("1");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.75f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0.25f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 0.5f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.125f;
                }
            }
            StartCoroutine(SecondRealSymptoms());
        }

        public IEnumerator SecondRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(4.5f, 10f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("2");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.55f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().Health / 1.75f;
                }
            }
            StartCoroutine(ThirdRealSymptoms());
        }
        public IEnumerator ThirdRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(4f, 6f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("3");
            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int Random = UnityEngine.Random.Range(0, 2);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = 0.1f;
                }
            }
            StartCoroutine(LastRealSymptoms());
        }
        public IEnumerator LastRealSymptoms()
        {
            float RandomTime = UnityEngine.Random.Range(15f, 22.5f);
            yield return new WaitForSeconds(RandomTime);
            Debug.Log("4");
            //StartCoroutine(IdleSounds());
            GameObject HuskAudioTransform1 = new GameObject("HuskAudioTransform1");
            AudioSource HuskTransformAudioClip = HuskAudioTransform1.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip.pitch = RandomPitch;
            HuskTransformAudioClip.playOnAwake = false;
            HuskTransformAudioClip.minDistance = 5f;
            HuskTransformAudioClip.maxDistance = 25f;
            HuskTransformAudioClip.spatialBlend = 1.0f;
            HuskTransformAudioClip.clip = MainModClass.HuskTransformSound1;
            HuskTransformAudioClip.Play();

            GameObject HuskAudioTransform10 = new GameObject("HuskAudioTransform2");
            AudioSource HuskTransformAudioClip0 = HuskAudioTransform10.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch1 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip0.pitch = RandomPitch1;
            HuskTransformAudioClip0.playOnAwake = false;
            HuskTransformAudioClip0.minDistance = 5f;
            HuskTransformAudioClip0.maxDistance = 80f;
            HuskTransformAudioClip0.spatialBlend = 1.0f;
            HuskTransformAudioClip0.clip = MainModClass.HuskTransformSound2;
            HuskTransformAudioClip0.Play();

            GameObject HuskAudioTransform100 = new GameObject("HuskAudioTransform3");
            AudioSource HuskTransformAudioClip00 = HuskAudioTransform100.transform.gameObject.AddComponent<AudioSource>();
            float RandomPitch2 = UnityEngine.Random.Range(0.95f, 1.05f);
            HuskTransformAudioClip00.pitch = RandomPitch2;
            HuskTransformAudioClip00.playOnAwake = false;
            HuskTransformAudioClip00.minDistance = 5f;
            HuskTransformAudioClip00.maxDistance = 55f;
            HuskTransformAudioClip00.spatialBlend = 1.0f;
            HuskTransformAudioClip00.clip = MainModClass.HuskTransformSound3;
            HuskTransformAudioClip00.Play();

            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    int RandomAmountTentacle1 = UnityEngine.Random.Range(0, 3);
                    int RandomAmountClawType1 = UnityEngine.Random.Range(0, 3);
                    int RandomChanceForClaws1 = UnityEngine.Random.Range(0, 4);

                    int RandomChanceForExtraArms1 = UnityEngine.Random.Range(0, 5);
                    int RandomExtraArmsType1 = UnityEngine.Random.Range(0, 3);

                    if (RandomAmountTentacle1 == 0)
                    {

                    }
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }

                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.ForceSetAllLiquid(0f);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0.85f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.OxygenLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.AdrenalineLevel = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth = 2f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Health = x.transform.gameObject.GetComponent<LimbBehaviour>().InitialHealth;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Numbness = 0.0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().IsZombie = true;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HealBone();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BodyTemperature = 0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().FreezingTemperature = -75f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().DiscomfortingHeatTemperature = 50f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().BloodLiquidType = "T.E.A.R.S Virus";
                    double num = (double)x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType(), x.CirculationBehaviour.Limits.y);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BloodFlow = 1f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate = 0.0f;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.IsPump = x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.WasInitiallyPumping;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasLungs = false;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().HasBrain = false;
                
                    if (RandomAmountTentacle1 == 1)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                    if (RandomAmountTentacle1 == 2)
                    {
                        GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, x.transform.position, Quaternion.identity);
                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));
                    }
                }
            }

            int RandomFace = UnityEngine.Random.Range(0, 3);
            if(RandomFace == 0)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("TEARSBleedingEyes1");
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.localPosition = new Vector3(0.014425f, 0.0725f);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.TEARSBleedingEyes1;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;
            }
            if (RandomFace == 1)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("TEARSBleedingEyes1");
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.localPosition = new Vector3(0.014425f, 0.0725f);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.TEARSBleedingEyes2;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;
            }
            if (RandomFace == 2)
            {
                GameObject HuskInfectionFaceAnomaly = new GameObject("TEARSBleedingEyes1");
                HuskInfectionFaceAnomaly.transform.SetParent(this.transform);
                HuskInfectionFaceAnomaly.transform.localPosition = new Vector3(0.014425f, 0.0725f);
                HuskInfectionFaceAnomaly.transform.rotation = transform.rotation;
                HuskInfectionFaceAnomaly.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = HuskInfectionFaceAnomaly.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.TEARSBleedingEyes3;
                spriteRenderer.sortingLayerName = "Foreground";
                spriteRenderer.sortingOrder = 1;
            }
            ShouldPlayTransformationSound = false;
            HasFullyTranformed = true;
        }
    }
}